#map+LCA# Codeforces Round #362 (Div. 2)-C. Lorenzo Von Matterhorn

2018-03-16

http://codeforces.com/problemset/problem/697/C

C. Lorenzo Von Matterhorn
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Barney lives in NYC. NYC has infinite number of intersections numbered with positive integers starting from 1. There exists a bidirectional road between intersections i and 2i and another road between i and 2i + 1 for every positive integer i. You can clearly see that there exists a unique shortest path between any two intersections.

Initially anyone can pass any road for free. But since SlapsGiving is ahead of us, there will q consecutive events happen soon. There are two types of events:

1. Government makes a new rule. A rule can be denoted by integers v, u and w. As the result of this action, the passing fee of all roads on the shortest path from u to v increases by w dollars.

2. Barney starts moving from some intersection v and goes to intersection u where there's a girl he wants to cuddle (using his fake name Lorenzo Von Matterhorn). He always uses the shortest path (visiting minimum number of intersections or roads) between two intersections.

Government needs your calculations. For each time Barney goes to cuddle a girl, you need to tell the government how much money he should pay (sum of passing fee of all roads he passes).

Input

The first line of input contains a single integer q (1 ≤ q ≤ 1 000).

The next q lines contain the information about the events in chronological order. Each event is described in form 1 v u w if it's an event when government makes a new rule about increasing the passing fee of all roads on the shortest path from u to v by w dollars, or in form 2 v u if it's an event when Barnie goes to cuddle from the intersection v to the intersection u.

1 ≤ v, u ≤ 1018, v ≠ u, 1 ≤ w ≤ 109 states for every description line.

Output

For each event of second type print the sum of passing fee of all roads Barney passes in this event, in one line. Print the answers in chronological order of corresponding events.

Example
Input
 
7
1 3 4 30
1 4 1 2
1 3 6 8
2 4 3
1 6 1 40
2 3 7
2 2 4
Output
94
0
32
Note

In the example testcase:

Here are the intersections used:

  1. Intersections on the path are 3, 1, 2 and 4.
  2. Intersections on the path are 4, 2 and 1.
  3. Intersections on the path are only 3 and 6.
  4. Intersections on the path are 4, 2, 1 and 3. Passing fee of roads on the path are 32, 32 and 30 in order. So answer equals to 32 + 32 + 30 = 94.
  5. Intersections on the path are 6, 3 and 1.
  6. Intersections on the path are 3 and 7. Passing fee of the road between them is 0.
  7. Intersections on the path are 2 and 4. Passing fee of the road between them is 32 (increased by 30 in the first event and by 2 in the second).

 

#LCA详解

#map详解

题意:先给出q次操作,当输入1的时候,表示一棵完全二叉树的两个节点u、v之间最短路径的权值全部加上w,当输入2的时候,表示询问这棵树的u到v节点间最短路径的权值之和。

解析:一棵二叉树!从任意一个点出发往上爬最多只要64步就能爬到顶点了,可以暴力。然后就是LCA思想。存入权值和计算最短路径的权值一样思路。为什么map?因为数值很大,不能用数组存,所以一边建点一边存入权值(加到对应一对点中较大点的map上)。

复杂度:O(q*log(n)*log(n))其中map的复杂度是log(n)

Code:

 1 #include<string.h>
 2 #include<cmath>
 3 #include<cstdio>
 4 #include<algorithm>
 5 #include<iostream>
 6 #include<vector>
 7 #include<queue>
 8 #include<string>
 9 #include<map>         //map
10 using namespace std;
11 #define MAX 0x3f3f3f3f
12 #define fi first
13 #define se second
14 #define ll long long
15 
16 map < ll,ll > mp;      //map 因为数据太大了,不能使用数组
17 
18 int main()
19 {
20     int q;
21     ll t,v,u,w;
22     while(cin>>q)
23     {
24 
25         for(int i=1;i<=q;i++)
26         {
27             /*cin>>t>>v>>u>>w;*/
28             cin>>t;
29             if(t==1)
30             {
31                 cin>>v>>u>>w;
32                 while(v!=u)
33                 {
34                    if(v < u)
35                    {
36                        swap(v,u);
37                    }
38 
39                    mp[v]+=w;
40                    v/=2;               //这个点一定是从它的/2过来的
41                 }
42             }
43             else
44             {
45                 cin>>v>>u;
46                 ll ans=0;
47                 while(v!=u)
48                 {
49                     if(v<u)
50                     {
51                         swap(v,u);
52                     }
53                     ans+=mp[v];
54                     v/=2; 
55                 }
56                 cout<<ans<<endl;
57             }
58 
59         }
60 
61     }
62 
63 }

 

posted @ 2018-03-16 20:19  LLbinGG  阅读(210)  评论(0编辑  收藏  举报